  '---------------------------------------------------
  '        Time CMM2 SD card RW Mode 1,8 
  ' Write, read and delete 1 to 150 images of selected 
  ' size to the CMM2 SD card, and time each operation
  '            Sized for Mode 1 only.
  '--------------------------------------------------- 
  OPTION EXPLICIT
  OPTION DEFAULT NONE
 
  DIM FLOAT HorzPos,VertPos,BoxWidth,BoxHeight
  DIM INTEGER ImgSize,TotalImg
  DIM INTEGER NumOfBars,ct,Tmpkey,z,TestCount,Colours(7),sp
  DIM FLOAT T1,T2,T3,T4,ImgFilesize,MenuBoxTop,MenuBoxLeft
  DIM STRING TmpStr
  
  Colours(1)=RGB(255,0,0)    'red
  Colours(2)=RGB(0,128,0)    'green
  Colours(3)=RGB(0,0,255)    'blue
  Colours(4)=RGB(255,165,0)  'orange
  Colours(5)=RGB(255,255,0)  'yellow
  Colours(6)=RGB(75,0,130)   'indigo
  NumOfBars=6
  
  TotalImg=5 : ImgSize=6 : Mode 1,8 : Page write 0
  GetOptions()
  DisplayOpt()

  do
    Tmpkey=asc(inkey$)
    
    Select Case TmpKey
      case 0
        TmpKey=-1
      case 58 to 177 
        Select case chr$(TmpKey)
          case "q","Q"
            SaveOptions()
            cls : print : OPTION LIST : end
          case "r","R"
            RunTest()
            DisplayOpt()
          case "f","F"
            SaveOptions()
            AskSave()
            option sd timing fast
          case "n","N"
            SaveOptions()
            AskSave()
            option sd timing normal
          case "s", "S"
            AskSave()
            DisplayOpt()   
          case "w","W"
            print @(1,270)
            Line input "Enter the number of images to write / read : ",TmpStr
            TotalImg=val(TmpStr)
            if TotalImg<1 then TotalImg=1
            if TotalImg>150 then TotalImg=150
            ImgFilesize=0 : T1=0 : T2=0 : T3=0
            DisplayOpt()
        end select
      case 48 to 57 
        TmpKey=TmpKey-48
    end Select
    
    select case Tmpkey
      case 0 to 9
        ImgSize=10-TmpKey
        T1=0 : T2=0 : T3=0 : ImgFilesize=0
        DisplayOpt()
      case 27
        SaveOptions()
        cls : print : option list : end
    end select
  LOOP

Sub DisplayOpt()
  cls
  MenuBoxLeft=50 : MenuBoxTop=50
  box MenuBoxLeft,MenuBoxTop,300,220,2,rgb(white),rgb(gray)
  MenuBoxLeft=MenuBoxLeft+10 
  text MenuBoxLeft,MenuBoxTop+10,"[ 0...9 ] Image size",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+40,"[ W ] Number of images to create",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+70,"[ R ] RUN TEST",,,,rgb(brown),-1
  text MenuBoxLeft,MenuBoxTop+100,"[ N ] SD speed normal",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+130,"[ F ] SD speed fast",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+160,"[ S ] Save Results",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+190,"[ Q ] or ESC to Quit",,,,rgb(yellow),-1

  MenuBoxLeft=450 : MenuBoxTop=50
  box MenuBoxLeft,MenuBoxTop,300,220,2,rgb(white),rgb(gray)
  MenuBoxLeft=MenuBoxLeft+10
  text MenuBoxLeft+100,MenuBoxTop+10,"RESULTS",,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+40,"Images size "+Bytes2KbGbMb(ImgFilesize),,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+70,"Total R/W "+Bytes2KbGbMb(ImgFilesize*TotalImg),,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+100,"Save "+str$(TotalImg)+" images "+ Val2sec_ms(T1),,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+130,"Load "+str$(TotalImg)+" images "+Val2sec_ms(T2),,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+160,"Delete "+str$(TotalImg)+" images "+Val2sec_ms(T3),,,,rgb(yellow),-1
  text MenuBoxLeft,MenuBoxTop+190,"Total time "+Val2sec_ms(T4),,,,rgb(yellow),-1

  MenuBoxLeft=90 : MenuBoxTop=320
  box MenuBoxLeft,MenuBoxTop,580,110,2,RGB(red),rgb(white) 
  MenuBoxLeft=MenuBoxLeft+10 
  TmpStr=str$(MM.HRES/ImgSize,0,0)+"x"+str$(MM.VRES/ImgSize,0,0)
  TmpStr=TmpStr+" is the selected image size for the SD test write and read"
  text MenuBoxLeft,MenuBoxTop+15,TmpStr,,,,rgb(black),-1
  TmpStr=Bytes2KbGbMb((MM.HRES/ImgSize)*(MM.VRES/ImgSize)*3)+" is the rough calculated file size"
  text MenuBoxLeft,MenuBoxTop+45,TmpStr,,,,rgb(black),-1
  TmpStr=str$(TotalImg)+" images will be written " 
  TmpStr=TmpStr+"for a total SD write value of "+Bytes2KbGbMb(((MM.HRES/ImgSize-1)*(MM.VRES/ImgSize)*3)*TotalImg)
  text MenuBoxLeft,MenuBoxTop+75,TmpStr,,,,rgb(black),-1

  box  90,440,580,30,2,rgb(white),rgb(red)
  text 100,450,"NOTE: The CMM2 will restart on option 1 and 2, Press F2 after restart",,1,,rgb(black),-1
end sub

Sub RunTest()    
  cls
  BoxHeight=MM.VRES/ImgSize : BoxWidth=(MM.HRES/ImgSize)/NumOfBars
  HorzPos=MM.HRES/2-(BoxWidth*NumOfBars)/2
  VertPos=MM.VRES/2-(BoxHeight/2)
  for ct=1 to NumOfBars
    BOX HorzPos,VertPos,Boxwidth,BoxHeight,1,Colours(ct),colours(ct)
    HorzPos=HorzPos+Boxwidth
  next

  HorzPos=mm.hres/2-(BoxWidth*NumOfBars)/2
  if ImgSize=1 then sp=mm.Vres-20 else sp=VertPos+BoxHeight+10
  timer=0
  for z=1 to TotalImg
    Text 337,sp,"Writing Image "+str$(z)
    Save IMAGE "Test"+str$(z)+".bmp",HorzPos,VertPos,BoxWidth*NumOfBars,BoxHeight
  next
  T1=Timer
  
  cls
  timer=0
  for z=TotalImg to 1 step -1
    Load BMP "Test"+str$(z)+".bmp",rnd*(mm.hres-BoxWidth*NumOfBars),rnd*(mm.vres-BoxHeight)'400
  next
  T2=Timer
  ImgFilesize=MM.INFO(FILESIZE "Test"+str$(1)+".bmp")
  cls
  timer=0
  for z=1 to TotalImg
    kill "Test"+str$(z)+".bmp"
  next
  T3=timer

  T4=T1+T2+T3
end sub  
  
Function Val2sec_ms(ThisVal as float) as string
  If Thisval >= 1000 then
    Val2sec_ms=str$(Thisval/1000,0,3)+" seconds"
  else
    Val2sec_ms=str$(Thisval,0,3)+" ms"
  endif
End Function
  
Function Bytes2KbGbMb(ThisVal as float) as string
  local float tmpin : local string Tstr
  select case ThisVal
    case >= 1073741824
      tmpin=ThisVal/1073741824 : Tstr=" GB"
    case > 1048576
      tmpin = ThisVal/1048576 : Tstr=" MB"
    case > 1024
      tmpin = ThisVal/1024 : Tstr=" KB"
    case Else
      tmpin=ThisVal : Tstr=" bytes"
  end select
  Bytes2KbGbMb=Str$(tmpin,0,3) + Tstr
End Function
  
Sub AskSave()
  print @(1,270)
  Line input "Save results to file ???.txt: ",TmpStr
  if TmpStr<>"" then SaveResults(TmpStr)
end sub

Sub SaveResults(Fname as string)
  Open Fname+".txt" for OUTPUT as #1
  Print #1,"Total Images: "+tab(3)+Str$(TotalImg)
  Print #1,"Image Size: "+tab(5)+str$(MM.VRES/ImgSize,0,0)+"x"+ str$(MM.HRES/ImgSize,0,0)
  Print #1,"Write images: "+tab(3)+Val2sec_ms(T1)
  Print #1,"Read images: "+tab(4)+Val2sec_ms(T2)
  Print #1,"Delete images: "+tab(2)+Val2sec_ms(T3)
  Print #1,"Total time: "+tab(5)+Val2sec_ms(T4)
  close #1
end sub

Sub SaveOptions()
 on error ignore
 Open "SdTst.ini" For OUTPUT as #2

 if mm.errno <> 0 then 
   cls
   print "File Error "+mm.errmsg$ 
   on error abort
   exit sub
 endif  

  Print #2,Str$(TotalImg)
  Print #2,Str$(ImgSize)

 if mm.errno <> 0 then 
   cls
   print "Write Error "+mm.errmsg$ 
 endif   
  close #2 
  on error abort
end sub

Sub GetOptions()
 local string o1,o2

 on error ignore
 open "SdTst.ini" for INPUT as #2
 if mm.errno <> 0 then 
   cls
   print "File Error "+mm.errmsg$ 
   on error abort
   exit sub 
 endif  

  Line Input #2,o1
  Line Input #2,o2  
  TotalImg=val(o1)
  ImgSize=val(o2)

 if mm.errno <> 0 then 
   cls
   print "Read Error "+mm.errmsg$
endif
   
  close #2 
  on error abort
end sub

